%% Deconvolution
close all, clear all
img = imread('city.png');
figure; colormap(gray(256)); imagesc(img); axis equal; axis off
%% Crop a light
a = imread('city_psf.png');
figure; colormap(gray(256)); imagesc(a); axis equal; axis off
%% Create impuse response function / point spread function
a = a(:,:,1); % red channel
a = a-40;
a = double(a)/sum(a(:));
imagesc(a); axis equal; axis off
sz = size(img);
asz = floor(size(a)/2);
h = zeros(sz(1:2));
h(ceil((sz(1)+1)/2)+(-asz(1):asz(1)),ceil((sz(2)+1)/2)+(-asz(2):asz(2))) = a;
h = fftshift(h);
%% Wiener filtering
F = fft2(img);
H = fft2(h);
H = repmat(H,[1,1,3]);
K = 0.02;
G = ( F ./ H ) .* ( abs(H).^2 ./ ( abs(H).^2 + K ) );
g = real(ifft2(G));
g(g<0) = 0;
g = g/max(g(:));
imagesc(g); axis equal; axis off
